class TR33:
    def __init__(
        self,
        name,
        pseudo_code,
        n=0,
        lst_variable=None,
        children=None,
        variables=None,
        parent=None,
        main=False,
    ):
        if children == None:
            children = []
        if variables == None:
            variables = []
        if lst_variable == None:
            lst_variable = []
        # format pour variables: lst [ [nom de variable,type, flot (inout..), conditions] ...]
        # conditions est une liste de chaine de charactère
        # lst_var est une liste à donner à chaques branche d'un même R0
        # pseudo_code : str
        # children : un objet tr33
        # parent : un objet tr33

        self.lst_variable = lst_variable
        self.pseudo_code = pseudo_code
        self.n = n
        self.name = name
        self.parent = parent
        self.children = children
        self.variables = variables
        self.txt = "R" + str(n) + " : Comment '" + name + "'\n"

        for var in variables:
            condition = var[-1]
            txt1 = var[0]
            txt1 = txt1 + " : " + var[1] + " |  " + var[2]

            if condition != []:
                txt2 = "{" + condition.join(";") + "}"
            else:
                txt2 = ""

            self.txt += "    " + txt1 + "\n        " + txt2 + "\n"

            to_add = []
            if var not in self.lst_variable:
                to_add.append(self.lst_variables.append(var))

            self.lst_variable += to_add

    def add_child(self, child, reset=False):
        # child : un object tr33 +/- vide

        if not reset:
            child.n = self.n + 1

        if child.parent == None:
            child.parent = self

        self.children.append(child)

    def add_var(self, n_var, type_, flot, condition):
        var = [n_var, type_, flot, condition]

        txt1 = var[0]
        txt1 = txt1 + " : " + var[1] + " |  " + var[2]

        if condition != []:
            txt2 = "{" + "; ".join(condition) + "}"
        else:
            txt2 = ""

        self.txt += "    " + txt1 + "\n        " + txt2 + "\n"

        if var not in self.lst_variable:
            self.lst_variable.append(var)
            self.variables.append(var)

    def __str__(self):
        if self.n == 0:
            txt = "R0 : " + self.name + "\n\n"
            # on dois faire un parcour ittératif de l'arbre pr avoir le bon ordre des R0,R1...
            lilo = self.children[:]  # last in last out
            while lilo != []:
                txt += str(lilo[0])
                for grand_children in lilo[0].children:
                    lilo.append(grand_children[:])

                del lilo[0]

            return txt

        return self.txt + self.pseudo_code + "\n" + "\n"

    def lst_var(self):
        return self.lst_variable

    def to_dict(self):
        return {
            "name": self.name,
            "depth": self.n,
            "variables": self.lst_variable,
            "pseudo_code": self.pseudo_code,
            "children": [c.to_dict() for c in self.children],
        }

    @classmethod
    def from_dict(cls, o):
        root = cls(
            n=o["depth"],
            name=o["name"],
            pseudo_code=o["pseudo_code"],
        )

        for serialized_variable in o["variables"]:
            root.add_var(*serialized_variable)

        for serialized_child in o["children"]:
            root.add_child(
                cls.from_dict(serialized_child), reset=True
            )  # real n is stored in o["depth"], incrementing here would result in a double increment

        return root
